<?php

function makeTempAvatar($username){ 

	header("Content-type: image/png");
	$name = htmlspecialchars(stripslashes(trim($username)));
	$inicial = strtoupper($name[0]);
	$avatar = imagecreatetruecolor(60,60);
	$r = mt_rand(0, 255);
	$g = mt_rand(0, 255);
	$b = mt_rand(0, 255);

    $bg_color = imagecolorallocate($avatar, $r, $g, $b);
    imagefill($avatar,0,0,$bg_color);

    $hex_color = sprintf("#%02x%02x%02x",$r,$g,$b);
    $t_color = getContrastColor($hex_color);

    list($R, $G, $B) = sscanf($t_color, "#%02x%02x%02x");


    $avatar_text_color = imagecolorallocate($avatar, $R, $G, $B);
    $font = imageloadfont('./styles/resource/gd-files/gd-font.gdf');
    imagestring($avatar, $font, 10, 10, strtoupper($inicial), $avatar_text_color);
    imagepng($avatar);
}

function getContrastColor($hexColor) {

    $R1 = hexdec(substr($hexColor, 1, 2));
    $G1 = hexdec(substr($hexColor, 3, 2));
    $B1 = hexdec(substr($hexColor, 5, 2));

    $blackColor = "#000000";
    $R2BlackColor = hexdec(substr($blackColor, 1, 2));
    $G2BlackColor = hexdec(substr($blackColor, 3, 2));
    $B2BlackColor = hexdec(substr($blackColor, 5, 2));

     $L1 = 0.2126 * pow($R1 / 255, 2.2) +
           0.7152 * pow($G1 / 255, 2.2) +
           0.0722 * pow($B1 / 255, 2.2);

    $L2 = 0.2126 * pow($R2BlackColor / 255, 2.2) +
          0.7152 * pow($G2BlackColor / 255, 2.2) +
          0.0722 * pow($B2BlackColor / 255, 2.2);

    $contrastRatio = 0;
    if ($L1 > $L2) {
        $contrastRatio = (int)(($L1 + 0.05) / ($L2 + 0.05));
    } else {
        $contrastRatio = (int)(($L2 + 0.05) / ($L1 + 0.05));
    }

    if ($contrastRatio > 5) {
        return '#000000';
    } else { 
        return '#FFFFFF';
    }
}